{ open Day7_parser }

rule token = parse
| "bag" 's'? { BAGS }
| "contain"  { CONTAIN }
| "no"       { NO }
| "other"    { OTHER }
| ','        { COMMA }
| '.'        { DOT }
| (['a'-'z' 'A'-'Z']+ as word)
    { WORD word }
| (['0'-'9']+ as num)
    { NUMBER (int_of_string num) }
| [' ' '\t' '\n']
    { token lexbuf }
| eof { EOF }
