include module type of Stdlib.Seq

val for_all: ('a -> bool) -> 'a t -> bool
val exists: ('a -> bool) -> 'a t -> bool

val span': ('a -> bool) -> 'a t -> ('a list * 'a t) option
val break': ('a -> bool) -> 'a t -> ('a list * 'a t) option

val span: ('a -> bool) -> 'a t -> 'a list * 'a t
val break: ('a -> bool) -> 'a t -> 'a list * 'a t

val drop_while: ('a -> bool) -> 'a t -> 'a t


val chunks: sep:('a -> bool) -> 'a t -> 'a list t

val line_chunks': string t -> string list t
val line_chunks: ?join:string -> string t -> string t

val mapi: (int -> 'a -> 'b) -> 'a t -> 'b t
val with_index: 'a t -> (int * 'a) t
